'Create a FileSystemObject
Set oFS = CreateObject("Scripting.FileSystemObject")
'Open a text file of computer names
'with one computer name per line
Set oTS = oFS.OpenTextFile("computers.txt")

'go through the text file
Do Until oTS.AtEndOfStream
On Error Resume Next
 'get the next computer name
 'store it in variable sComputer
 sComputer = oTS.ReadLine

If IsConnectible(sComputer, "", "") Then

'==========================================================================
'
' NAME: 	WorkstationAdminGroups.vbs
'
' AUTHOR: 	Adam Freden 
' DATE  : 	5/18/2006
'
' COMMENT:	This is designed to be a logon script, but can easily be modified.
'			to a stand-alone script (for instance, use a "multiple computer
'			wrapper" script (available at www.ScriptingAnswers.com) to allow
'			the reading of computer names from a text file or Active Directory.
'==========================================================================
'			This will add three groups (defined in the "Variable declarations"
'			section below) to the local 'Administrators' group of only 
'			workstation-class Windows 2000 and XP computers.  This will not 
'			modify local group membership of server-class Windows computers
'			or any other class of computer.  There are inline comments throughout.
'
'==========================================================================

' Variable declarations and assignments
  Dim objNet
  Dim objFS
  Dim LogFile
  Dim strTextStream
  Domain = "DOMAIN"					' Replace this with your domain name
  
  ' These will be the domain groups that will be added to the local Administrators group
  GroupName1 = "group1"				' Replace this with your first group name	
  GroupName2 = "group2"				' Replace this with your second group name	
  GroupName3 = "group3"				' Replace this with your third group name	

  
' Get Name of of Local Computer - although the WMI query will work with just a ".", the logging
' will totally suck - especially if used in a logon script (you won't be able to look at the log  
' to see which computer was being referenced in any given line).  Therefore, when we use this to  
' grab the actual local computer name, the logging will reflect that.
'Set objNet = CreateObject("WScript.NetWork") 
ComputerName = sComputer

' Create a new file system object - this is for the centralized log file
Set objFS = CreateObject("Scripting.FileSystemObject")

' Get Name of Log File
LogFile = "log.txt" ' Change this to your centralized server & sharename.
									' Make sure it's writable by all users!  Probably 
									' best to use a hidden share, to obscure the log file.

' Determine whether this is a workstation OS or a server OS
' - - - We only want DOMAIN ADMINS to be server administrators
Set objWMIService = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & ComputerName & "\root\cimv2")
Set colOperatingSystems = objWMIService.ExecQuery ("SELECT * FROM Win32_OperatingSystem")
For Each objOperatingSystem in colOperatingSystems
 strOsType = objOperatingSystem.Caption ' Get the Operating System description and place in StrOsType variable
 If InStr(strOsType,"Server") Then
 	' If the string 'Server' is in the 'strOsType' variable, then skip the update and log the reason
 	strMsg = " - This is a server system - Skip this computer.  OS=" & strOsType
 	LogResult = WriteLog(ComputerName,strMsg)
 	' Clear out the variables (so there's no way for us to reuse the value later on and screw things up
 	strMsg = Null 
 	strOsType = Null 
 Elseif InStr(strOsType,"Professional") Then
 	' If the string 'Professional' is in the 'strOsType' variable, then try to add the three groups
 	' ------------------
	' Add the 'CSC Team' group to the local administrators group
	  Select Case AddGroupToLocalAdmins(ComputerName,Domain,GroupName1)
	    Case 0
	      ' Write a seperator line in the log file, to visually separate different computers in the log file
	      strMsg = "-------------------------------------------"
	      LogResult2 = WriteLog("----------",strMsg)
	      LogResult2 = Null 
	      strMsg = Null 
	      strMsg = GroupName1 & " added to the local ADMINISTRATORS group"
	      LogResult = WriteLog(ComputerName,strMsg)
	      ' Clear out the variables (so there's no way for us to reuse the value later on and screw things up)
	      strMsg = Null 
	    Case 1
	      ' Write a seperator line in the log file, to visually separate different computers in the log file
	      strMsg = "-------------------------------------------"
	      LogResult2 = WriteLog("----------",strMsg)
	      LogResult2 = Null 
	      strMsg = Null 
	      strMsg = GroupName1 & " failed - unable to add the group to the local administrators group"
	      LogResult = WriteLog(ComputerName,strMsg)
	      ' Clear out the variables (so there's no way for us to reuse the value later on and screw things up)
	      strMsg = Null 
	    Case 2
	      ' Write a seperator line in the log file, to visually separate different computers in the log file
	      strMsg = "-------------------------------------------"
	      LogResult2 = WriteLog("----------",strMsg)
	      LogResult2 = Null 
	      strMsg = Null 
	      strMsg = GroupName1 & " is already a member of the local ADMINISTATORS group"
	      LogResult = WriteLog(ComputerName,strMsg)
	      ' Clear out the variables (so there's no way for us to reuse the value later on and screw things up)
	      strMsg = Null 
	    Case 3
	      ' Write a seperator line in the log file, to visually separate different computers in the log file
	      strMsg = "-------------------------------------------"
	      LogResult2 = WriteLog("----------",strMsg)
	      LogResult2 = Null 
	      strMsg = Null 
	      strMsg GroupName1 & " failed - Unable to connect to the computer"
	      LogResult = WriteLog(ComputerName,strMsg)
	      ' Clear out the variables (so there's no way for us to reuse the value later on and screw things up)
	      strMsg = Null 
	  End Select  
	
	'Add the 'Entex SAV' group to the local administrators group
	  Select Case AddGroupToLocalAdmins(ComputerName,Domain,GroupName2)
	    Case 0
	      strMsg = GroupName2 & " Added to the local ADMINISTRATORS group"
	      LogResult = WriteLog(ComputerName,strMsg)
	      ' Clear out the variables (so there's no way for us to reuse the value later on and screw things up)
	      strMsg = Null 
	    Case 1
	      strMsg = GroupName2 & " failed - unable to add the group to the local administrators group"
	      LogResult = WriteLog(ComputerName,strMsg)
	      ' Clear out the variables (so there's no way for us to reuse the value later on and screw things up)
	      strMsg = Null 
	    Case 2
	      strMsg = GroupName2 & " is already a member of the local ADMINISTATORS group"
	      LogResult = WriteLog(ComputerName,strMsg)
	      ' Clear out the variables (so there's no way for us to reuse the value later on and screw things up)
	      strMsg = Null 
	    Case 3
	      strMsg = GroupName2 & " failed - Unable to connect to the computer"
	      LogResult = WriteLog(ComputerName,strMsg)
	      ' Clear out the variables (so there's no way for us to reuse the value later on and screw things up)
	      strMsg = Null 
	  End Select
	
	'Add the 'Domain Admins' group to the local administrators group
	  Select Case AddGroupToLocalAdmins(ComputerName,Domain,GroupName3)
	    Case 0
	      strMsg = GroupName3 & " Added to the local ADMINISTRATORS group"
	      LogResult = WriteLog(ComputerName,strMsg)
	      ' Clear out the variables (so there's no way for us to reuse the value later on and screw things up)
	      strMsg = Null 
	    Case 1
	      strMsg = GroupName3 & " failed - unable to add the group to the local administrators group"
	      LogResult = WriteLog(ComputerName,strMsg)
	      ' Clear out the variables (so there's no way for us to reuse the value later on and screw things up)
	      strMsg = Null 
	    Case 2
	      strMsg = GroupName3 & " is already a member of the local ADMINISTATORS group"
	      LogResult = WriteLog(ComputerName,strMsg)
	      ' Clear out the variables (so there's no way for us to reuse the value later on and screw things up)
	      strMsg = Null 
	    Case 3
	      strMsg = GroupName3 & " failed - Unable to connect to the computer"
	      LogResult = WriteLog(ComputerName,strMsg)
	      ' Clear out the variables (so there's no way for us to reuse the value later on and screw things up)
	      strMsg = Null 
	  End Select
	  ' Clear out the variables (so there's no way for us to reuse the value later on and screw things up)
	  strOsType = Null 
 Else 
 	strMsg = " - DID NOT ATTEMPT - Could not determine Operating System Type.  OS Type = " & strOsType
 	LogResult = WriteLog(ComputerName,strMsg)
	' Clear out the variables (so there's no way for us to reuse the value later on and screw things up)
 	strMsg = Null 
 	strOsType = Null
 End If
Next

End If

  Loop
'#############################
'Function AddGroupToLocalAdmins

'Variables
  'ComputerName
  'Domain of Group being added
  'GroupName (User account can be used as well)
  
'Returns
  '0 if Group is added successfully to the local Admin group
  '1 if function was unable to add the Group to the local Admin group
  '2 if Group is already a member of the local Admin group
  '3 if the function was unable to connect to the specified Computer

  Function AddGroupToLocalAdmins(ComputerName,Domain,GroupName)

    On Error Resume Next

'Create a group object referencing the local Administrators group on the computer
    Set objLocalGroup = GetObject("WinNT://" & ComputerName & "/Administrators, group")
    If Err.Number = 0 Then

'Check to see if the Group already exists in the local Admin group
      For each Group in objLocalGroup.Members 
        If Instr(ucase(Group.ADSPath),ucase(Domain & "/" & GroupName)) <> 0 Then
          AlreadyExists = True
        End If
      Next

'Add the specified group to the local Administrators group if it doesn't already exist
      If AlreadyExists = False Then
        objLocalGroup.Add("WinNT://" & Domain & "/" & GroupName)

        If Err.Number = 0 Then   ' If there's no error, then the return value will be "0" for AddGroupToLocalAdmins
          AddGroupToLocalAdmins = 0
          Err.Clear
        Else
          AddGroupToLocalAdmins = 1 ' If there was an error attempting to add the group, then the return value will be "1"
          Err.Clear
        End If

      Else
        AddGroupToLocalAdmins = 2 ' If the group already exists, then the return value will be "2" for AddGroupToLocalAdmins
        Err.Clear
      End If

    Else
      AddGroupToLocalAdmins = 3 ' If there was some other type of error, then the return value will be "3" for AddGroupToLocalAdmins
      Err.Clear
    End If
 
  End Function
    
' Log Results
Function WriteLog(strLocalComputer,strMsg)
	Dim strTextStream
	Set strTextStream = objFS.OpenTextFile(LogFile, 8, true)
	strTextStream.WriteLine(Date & vbTab & Time & vbTab & ComputerName & vbTab & strMsg)
	strTextStream.Close
	' strTextStream = Nothing 
End Function
        
'#############################
'close the text file
oTS.Close
MsgBox "Done!"

'-------------------- ISCONNECTIBLE --------------------.

Function IsConnectible(sHost, iPings, iTO)

   ' Restituisce vero o falso basandosi sull'output di ping.exe
   '
   ' Autore: Alex Angelopoulos/Torgeir Bakken
   ' Funziona su tutte le versioni di WSH
   ' sHost  l'hostname o l'IP
   ' iPings  il numero di tentativi di ping
   ' iTO  il timeout in millisecondi
   ' se i valori sono settati a "", allora verrano usati i valori di default qui sotto

   Const OpenAsASCII      =  0
   Const FailIfNotExist   =  0
   Const ForReading       =  1
   Dim oShell, oFSO, sTempFile, fFile

   If iPings = "" Then iPings = 2
   If iTO = "" Then iTO = 750

   Set oShell = CreateObject("WScript.Shell")
   Set oFSO = CreateObject("Scripting.FileSystemObject")

   sTempFile = oFSO.GetSpecialFolder(2).ShortPath & "\" & oFSO.GetTempName

   oShell.Run "%comspec% /c ping.exe -n " & iPings & " -w " & iTO _
      & " " & sHost & ">" & sTempFile, 0 , True

   Set fFile = oFSO.OpenTextFile(sTempFile, ForReading, _
                                     FailIfNotExist, OpenAsASCII)

   sResults = fFile.ReadAll
   fFile.Close
   oFSO.DeleteFile(sTempFile)
   IsConnectible = CBool(InStr(sResults, "TTL="))

End Function

'-------------------------------------------------------.